"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var graphql_transformer_core_1 = require("graphql-transformer-core");
var graphql_transformer_common_1 = require("graphql-transformer-common");
var AutoTransformer = /** @class */ (function (_super) {
    __extends(AutoTransformer, _super);
    function AutoTransformer() {
        var _this = _super.call(this, 'AutoTransformer', graphql_transformer_core_1.gql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        directive @auto(creatable: Boolean = false, updatable: Boolean = false) on FIELD_DEFINITION\n      "], ["\n        directive @auto(creatable: Boolean = false, updatable: Boolean = false) on FIELD_DEFINITION\n      "])))) || this;
        _this.field = function (parent, definition, directive, ctx) {
            var _a;
            if (parent.kind === graphql_1.Kind.INTERFACE_TYPE_DEFINITION) {
                throw new graphql_transformer_core_1.InvalidDirectiveError("The @auto directive cannot be placed on an interface's field. See " + parent.name.value + definition.name.value);
            }
            var modelDirective = (_a = parent.directives) === null || _a === void 0 ? void 0 : _a.find(function (dir) { return dir.name.value === 'model'; });
            if (!modelDirective) {
                throw new graphql_transformer_core_1.InvalidDirectiveError('Types annotated with @auto must also be annotated with @model.');
            }
            if (!graphql_transformer_common_1.isNonNullType(definition.type)) {
                throw new graphql_transformer_core_1.TransformerContractError("@auto directive can only be used on non-nullable type fields");
            }
            var isArg = function (s) { return function (arg) { return arg.name.value === s; }; };
            var getArg = function (arg, dflt) {
                var _a;
                var argument = (_a = directive.arguments) === null || _a === void 0 ? void 0 : _a.find(isArg(arg));
                return argument ? graphql_1.valueFromASTUntyped(argument.value) : dflt;
            };
            var creatable = getArg('creatable', false);
            var updatable = getArg('updatable', false);
            _this.updateCreateInput(ctx, parent.name.value, definition, creatable);
            _this.updateUpdateInput(ctx, parent.name.value, definition, updatable);
        };
        return _this;
    }
    AutoTransformer.prototype.updateCreateInput = function (ctx, typeName, autoField, nullable) {
        this.updateInput(ctx, graphql_transformer_common_1.ModelResourceIDs.ModelCreateInputObjectName(typeName), typeName, autoField, nullable);
    };
    AutoTransformer.prototype.updateUpdateInput = function (ctx, typeName, autoField, nullable) {
        this.updateInput(ctx, graphql_transformer_common_1.ModelResourceIDs.ModelUpdateInputObjectName(typeName), typeName, autoField, nullable);
    };
    AutoTransformer.prototype.updateInput = function (ctx, inputName, typeName, autoField, nullable) {
        var input = ctx.getType(inputName);
        if (input && input.kind === graphql_1.Kind.INPUT_OBJECT_TYPE_DEFINITION) {
            if (input.fields) {
                if (nullable) {
                    // make autoField nullable
                    ctx.putType(__assign(__assign({}, input), { fields: input.fields.map(function (f) {
                            if (f.name.value === autoField.name.value) {
                                return graphql_transformer_common_1.makeInputValueDefinition(autoField.name.value, graphql_transformer_common_1.unwrapNonNull(autoField.type));
                            }
                            return f;
                        }) }));
                }
                else {
                    // or strip autoField
                    var updatedFields = input.fields.filter(function (f) { return f.name.value !== autoField.name.value; });
                    if (updatedFields.length === 0) {
                        throw new graphql_transformer_core_1.InvalidDirectiveError("After stripping away version field \"" + autoField.name.value + "\",                         the create input for type \"" + typeName + "\" cannot be created                         with 0 fields. Add another field to type \"" + typeName + "\" to continue.");
                    }
                    ctx.putType(__assign(__assign({}, input), { fields: updatedFields }));
                }
            }
        }
    };
    return AutoTransformer;
}(graphql_transformer_core_1.Transformer));
exports.AutoTransformer = AutoTransformer;
var templateObject_1;
//# sourceMappingURL=AutoTransformer.js.map